package com.lymsh.yimiao.main.data.service.impl;

import com.lymsh.yimiao.main.data.dao.MedEmployeeMapper;
import com.lymsh.yimiao.main.data.model.MedEmployee;
import com.lymsh.yimiao.main.data.model.MedEmployeeQuery;
import com.lymsh.yimiao.main.data.service.MedEmployeeService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.util.Date;
import java.util.List;

@Service
public class MedEmployeeServiceImpl implements MedEmployeeService {

    @Autowired
    private MedEmployeeMapper medEmployeeMapper;

    @Override
    public void addMedEmployee(MedEmployee obj) {
        medEmployeeMapper.addMedEmployee(obj);
    }

    @Override
    public void updateMedEmployee(MedEmployee obj) {
        medEmployeeMapper.updateMedEmployee(obj);
    }

    @Override
    public void deleteMedEmployee(Integer id) {
        medEmployeeMapper.deleteMedEmployee(id);
    }

    @Override
    public MedEmployee getMedEmployee(String id) {
        return medEmployeeMapper.getMedEmployee(id);
    }

    @Override
    public int queryMedEmployeeCount(MedEmployeeQuery query) {
        return medEmployeeMapper.queryMedEmployeeCount(query);
    }

    @Override
    public List<MedEmployee> queryMedEmployee(MedEmployeeQuery query) {
        if (query.getNeed() != null) {
            query.mysqlBuild(medEmployeeMapper.queryMedEmployeeCount(query));
        }
        return medEmployeeMapper.queryMedEmployee(query);
    }

}