package com.lymsh.yimiao.main.data.service.impl;

import cn.jpush.api.JPushClient;
import cn.jpush.api.push.PushResult;
import cn.jpush.api.push.model.Platform;
import cn.jpush.api.push.model.PushPayload;
import cn.jpush.api.push.model.audience.Audience;
import cn.jpush.api.push.model.notification.Notification;
import com.lymsh.mommybaby.basecommon.util.DateUtil;
import com.lymsh.yimiao.main.data.enumdata.YnEnum;
import com.lymsh.yimiao.main.data.model.*;
import com.lymsh.yimiao.main.data.service.*;
import com.lymsh.yimiao.main.data.util.JPushUtil;
import org.apache.commons.collections.CollectionUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.context.ApplicationContext;
import org.springframework.context.support.ClassPathXmlApplicationContext;
import org.springframework.stereotype.Service;

import javax.annotation.Resource;
import java.util.Date;
import java.util.List;

/**
 *
 *  定时推送接种消息
 *
 * Created by Administrator on 2016/5/24 0024.
 */
@Service("pushTaskService")
public class PushTaskServiceImpl implements PushTaskService{

    @Autowired
    private JPushClient jPushClient;
    @Autowired
    private MedInoculateOrderService medInoculateOrderService;
    @Autowired
    private YmUserKidMapsService ymUserKidMapsService;
    @Autowired
    private YmUsersService ymUsersService;
    @Autowired
    private YmPushMessagesService ymPushMessagesService;
    @Autowired
    private MedKidsService medKidsService;
    @Autowired
    private MedVaccineNameService medVaccineNameService;

    private final static String isDelete = "1";

    public static final int THREE_DAY_SECONDS = 86400 * 1000 * 3;

    public static final int ONE_DAY_SECONDS = 86400 * 1000;

    private static final String ALERT = "您有一条新的推送";

    private static final String ALIAS = "yimiaoer";

    @Override
    public void pushTask() {
        //距离三天
        MedInoculateOrderQuery orderQuery = new MedInoculateOrderQuery();
        orderQuery.setIoIsDelete(isDelete);
        orderQuery.setIoInoculateDate(DateUtil.getyyyy_MM_dd(new Date(DateUtil.getStartTime() + THREE_DAY_SECONDS)).toString());
        List<MedInoculateOrder> orderList = medInoculateOrderService.queryMedInoculateOrder(orderQuery);
        if (CollectionUtils.isNotEmpty(orderList)){
            //距离当前还有三天就要接种的小孩
            for (MedInoculateOrder data : orderList){

                //接种的疫苗名称
                MedVaccineName medVaccineName = medVaccineNameService.getMedVaccineName(data.getIoVaccineId());

                YmUserKidMapsQuery mapsQuery = new YmUserKidMapsQuery();
                mapsQuery.setYn(YnEnum.yes.getId());
                mapsQuery.setKidId(data.getIoKidId());
                List<YmUserKidMaps> mapsList = ymUserKidMapsService.queryYmUserKidMaps(mapsQuery);
                //得到和小孩关联的账号
                if (CollectionUtils.isNotEmpty(mapsList)){
                    for (YmUserKidMaps temp : mapsList){

                        //得到小孩的名字
                        MedKids medKids = medKidsService.getMedKids(temp.getKidId());

                        YmUsersQuery usersQuery = new YmUsersQuery();
                        usersQuery.setYn(YnEnum.yes.getId());
                        usersQuery.setId(temp.getUserId());
                        //拿到最后所有需要发推送的用户
                        List<YmUsers> usersList = ymUsersService.queryYmUsers(usersQuery);
                        if (CollectionUtils.isNotEmpty(usersList)) {
                            YmUsers users = usersList.get(0);
                            PushPayload ios = JPushUtil.buildPushObjectAllAliasAlertIos(ALIAS + users.getPhone(), ALERT);
                            PushPayload android = JPushUtil.buildPushObjectAllAliasAlertAndroid(ALIAS + users.getPhone(), ALERT);
                            if (ios != null || android != null) {
                                YmPushMessages messages = new YmPushMessages();
                                messages.setCreated(new Date());
                                messages.setContent((medKids == null ? "" : medKids.getName() == null ? "" : medKids.getName()) + "小朋友按计划3天后将会接种" +
                                        (medVaccineName == null ? "" : medVaccineName.getVnName()) + ",请提前做好准备,准时到接种点接种疫苗。");
                                messages.setReceptionId(users.getId());
                                messages.setYn(YnEnum.yes.getId());
                                ymPushMessagesService.addYmPushMessages(messages);

                                //成功后推送提示消息
                                try {
                                    jPushClient.sendPush(ios);
                                    jPushClient.sendPush(android);
                                } catch (Exception e) {

                                }
                            }
                        }
                    }
                }
            }
        }
        //距离一天
        MedInoculateOrderQuery orderQuery1 = new MedInoculateOrderQuery();
        orderQuery1.setIoIsDelete(isDelete);
        orderQuery1.setIoInoculateDate(DateUtil.getyyyy_MM_dd(new Date(DateUtil.getStartTime() + ONE_DAY_SECONDS)).toString());
        List<MedInoculateOrder> orderList1 = medInoculateOrderService.queryMedInoculateOrder(orderQuery1);
        if (CollectionUtils.isNotEmpty(orderList1)){
            for (MedInoculateOrder data : orderList1){

                //接种的疫苗名称
                MedVaccineName medVaccineName = medVaccineNameService.getMedVaccineName(data.getIoVaccineId());

                YmUserKidMapsQuery mapsQuery = new YmUserKidMapsQuery();
                mapsQuery.setYn(YnEnum.yes.getId());
                mapsQuery.setKidId(data.getIoKidId());
                List<YmUserKidMaps> mapsList = ymUserKidMapsService.queryYmUserKidMaps(mapsQuery);
                //得到和小孩关联的账号
                if (CollectionUtils.isNotEmpty(mapsList)){
                    for (YmUserKidMaps temp : mapsList){

                        //得到小孩的名字
                        MedKids medKids = medKidsService.getMedKids(temp.getKidId());

                        YmUsersQuery usersQuery = new YmUsersQuery();
                        usersQuery.setYn(YnEnum.yes.getId());
                        usersQuery.setId(temp.getUserId());
                        //拿到最后所有需要发推送的用户
                        List<YmUsers> usersList = ymUsersService.queryYmUsers(usersQuery);
                        if (CollectionUtils.isNotEmpty(usersList)) {
                            YmUsers users = usersList.get(0);
                            PushPayload ios = JPushUtil.buildPushObjectAllAliasAlertIos(ALIAS + users.getPhone(), ALERT);
                            PushPayload android = JPushUtil.buildPushObjectAllAliasAlertAndroid(ALIAS + users.getPhone(), ALERT);
                            if (ios != null || android != null) {
                                YmPushMessages messages = new YmPushMessages();
                                messages.setCreated(new Date());
                                messages.setContent((medKids == null ? "" : medKids.getName() == null ? "" : medKids.getName()) + "小朋友按计划1天后将会接种" +
                                        (medVaccineName == null ? "" : medVaccineName.getVnName()) + ",请提前做好准备,准时到接种点接种疫苗。");
                                messages.setReceptionId(users.getId());
                                messages.setYn(YnEnum.yes.getId());
                                ymPushMessagesService.addYmPushMessages(messages);

                                //成功后推送提示消息
                                try {
                                    jPushClient.sendPush(ios);
                                    jPushClient.sendPush(android);
                                } catch (Exception e) {

                                }
                            }
                        }
                    }
                }
            }



        }


    }

}
