package com.lymsh.yimiao.main.data.util;

import org.apache.commons.io.FileUtils;

import java.io.File;
import java.io.IOException;
import java.sql.Connection;
import java.sql.DriverManager;
import java.sql.PreparedStatement;
import java.sql.ResultSet;
import java.util.ArrayList;
import java.util.List;

/**
 * Created by riecard on 15/3/26.
 */
public class GAllMysql {

    public static void main(String[] args) {
        GAllMysql g = new GAllMysql();
        g.generateAll();
    }

    String url = "jdbc:mysql://localhost/lyms_wxyl";
    String username = "root";
    String password = "landong";
    String packageStr = "com.lymsh.yimiao.main.data";
    String baseDir = "d:/yimiao/";
    public void generateAll() {
        try {
            Class.forName("com.mysql.jdbc.Driver");
            Connection conn = DriverManager.getConnection(url, username, password);
            PreparedStatement pst = conn.prepareStatement("show tables");
            ResultSet rs = pst.executeQuery();
            while (rs.next()) {
                generate(rs.getString(1));
                System.out.println(rs.getString(1));
            }
            rs.close();
            pst.close();
            conn.close();
        } catch (Exception e) {
            e.printStackTrace();
        }
    }

    public void generate(String tableName) {
        StringBuffer xml = new StringBuffer();
        StringBuffer pojo = new StringBuffer();
        StringBuffer mapper = new StringBuffer();
        StringBuffer impl = new StringBuffer();


        String className = "";
        String[] array = tableName.split("_");
        for (int i = 0; i < array.length; i++) {
            className += array[i].substring(0, 1).toUpperCase() + array[i].substring(1).toLowerCase();
        }
        List<TableInfo> list = execute(tableName);
        list = build(list);


        // xml header
        xml.append("<?xml version=\"1.0\" encoding=\"UTF-8\" ?>\n" +
                "<!DOCTYPE mapper PUBLIC \"-//mybatis.org//DTD Mapper 3.0//EN\" \"http://mybatis.org/dtd/mybatis-3-mapper.dtd\" >\n" +
                "<mapper namespace=\""+packageStr+".dao."+className+"Mapper\">\n");

        // resultMap
        xml.append("\n<resultMap id=\"" + className + "ResultMap\" type=\""+packageStr+".model." + className + "\">");
        for (TableInfo ti : list) {
            if ("auto_increment".equals(ti.auto)) {
                xml.append("\n<id column=\"" + ti.dbcolumn + "\" property=\"" + ti.javacloumn + "\" jdbcType=\"" + ti.ibatistype + "\" />");
            } else {
                xml.append("\n<result column=\"" + ti.dbcolumn + "\" property=\"" + ti.javacloumn + "\" jdbcType=\"" + ti.ibatistype + "\" />");
            }
        }
        xml.append("\n</resultMap>\n\n");

        // insert
        xml.append("\n\n<insert id=\"add" + className + "\" parameterType=\""+packageStr+".model." + className + "\">");
        xml.append("\ninsert into " + tableName + " (");
        for (int i = 0; i < list.size(); i++) {
            TableInfo ti = list.get(i);
            if (!"auto_increment".equals(ti.auto)) {
                xml.append(ti.dbcolumn);
                if (i != (list.size() - 1)) {
                    xml.append(",");
                }
            }
        }
        xml.append(") values (");
        for (int i = 0; i < list.size(); i++) {
            TableInfo ti = list.get(i);
            if (!"auto_increment".equals(ti.auto)) {
                xml.append("#{" + ti.javacloumn + "}");
                if (i != (list.size() - 1)) {
                    xml.append(",");
                }
            }
        }
        xml.append(")");
        xml.append("\n</insert>\n\n");

        // update
        xml.append("\n\n<update id=\"update" + className + "\" parameterType=\""+packageStr+".model." + className + "\">");
        xml.append("\nupdate " + tableName + " ");
        xml.append("<set>");
        for (int i = 0; i < list.size(); i++) {
            TableInfo ti = list.get(i);
            if (!"auto_increment".equals(ti.auto)) {
                if ("Integer".equals(ti.javatype) || "Double".equals(ti.javatype)) {
                    xml.append("<if test=\"" + ti.javacloumn + " != null and " + ti.javacloumn + " >= 0\">\n");
                } else if ("String".equals(ti.javatype)) {
                    xml.append("<if test=\"" + ti.javacloumn + " != null and " + ti.javacloumn + " != ''\">\n");
                } else if ("Date".equals(ti.javatype)) {
                    xml.append("<if test=\"" + ti.javacloumn + " != null\">\n");
                }
                xml.append(ti.dbcolumn + " = #{" + ti.javacloumn + ",jdbcType=" + ti.ibatistype + "},");
                xml.append("\n</if>\n");
            }
        }
        xml.append("</set>");
        for (int i = 0; i < list.size(); i++) {
            TableInfo ti = list.get(i);
            if ("auto_increment".equals(ti.auto)) {
                xml.append("\nwhere " + ti.dbcolumn + " = #{" + ti.javacloumn + ",jdbcType=" + ti.ibatistype + "}");
                break;
            }
        }
        xml.append("\n</update>\n\n");

        // delete
        xml.append("\n<delete id=\"delete" + className + "\" parameterType=\"java.lang.Integer\">");
        for (int i = 0; i < list.size(); i++) {
            TableInfo ti = list.get(i);
            if ("auto_increment".equals(ti.auto)) {
                xml.append("\ndelete from " + tableName + " where " + ti.dbcolumn + " = #{" + ti.javacloumn + ",jdbcType=" + ti.ibatistype + "}");
                break;
            }
        }
        xml.append("\n</delete>\n\n");

        // select one
        xml.append("\n\n<select id=\"get" + className + "\" resultMap=\"" + className + "ResultMap\" parameterType=\"java.lang.Integer\">");
        xml.append("\nselect ");
        for (int i = 0; i < list.size(); i++) {
            TableInfo ti = list.get(i);
            xml.append(ti.dbcolumn);
            if (i != (list.size() - 1)) {
                xml.append(",");
            }
        }
        System.out.println();
        for (int i = 0; i < list.size(); i++) {
            TableInfo ti = list.get(i);
            if ("auto_increment".equals(ti.auto)) {
                xml.append("\n from " + tableName + " where " + ti.dbcolumn + " = #{" + ti.javacloumn + ",jdbcType=" + ti.ibatistype + "}");
                break;
            }
        }
        xml.append("\n</select>\n\n");

        // order and limit
        xml.append("\n<sql id=\"orderAndLimit\">");
        xml.append("\n<if test=\"sort != null and sort != '' \">");
        xml.append("\norder by ${sort} ");
        xml.append("\n<if test=\"need != null\">");
        xml.append("\nlimit #{offset, jdbcType=INTEGER} , #{limit, jdbcType=INTEGER}");
        xml.append("\n</if>");
        xml.append("\n</if>");
        xml.append("\n</sql>\n\n");

        // condition
        xml.append("\n\n<sql id=\"" + className + "Condition\">");
        xml.append("\n<where>");
        xml.append("\n 1 = 1 ");

        for (int i = 0; i < list.size(); i++) {
            TableInfo ti = list.get(i);
            if ("Integer".equals(ti.javatype) || "Double".equals(ti.javatype)) {
                xml.append("\n<if test=\"" + ti.javacloumn + " != null and " + ti.javacloumn + " >= 0\">");
            } else if ("String".equals(ti.javatype)) {
                xml.append("\n<if test=\"" + ti.javacloumn + " != null and " + ti.javacloumn + " != ''\">");
            } else if ("Date".equals(ti.javatype)) {
                xml.append("\n<if test=\"" + ti.javacloumn + " != null\">");
            }
            xml.append("\nand " + ti.dbcolumn + " = #{" + ti.javacloumn + ",jdbcType=" + ti.ibatistype + "} ");
            xml.append("\n</if>");
        }

        xml.append("\n</where>");
        xml.append("\n</sql>\n\n");

        // select list
        xml.append("\n\n<select id=\"query" + className + "\" resultMap=\"" + className + "ResultMap\" parameterType=\""+packageStr+".model." + className + "Query\">");
        xml.append("\nselect ");
        for (int i = 0; i < list.size(); i++) {
            TableInfo ti = list.get(i);
            xml.append(ti.dbcolumn);
            if (i != (list.size() - 1)) {
                xml.append(",");
            }
        }
        System.out.println();
        xml.append("\n from " + tableName + " ");
        xml.append("\n<include refid=\"" + className + "Condition\" />");
        xml.append("\n<include refid=\"orderAndLimit\" />");
        xml.append("\n</select>\n\n");

        // select count
        xml.append("\n\n<select id=\"query" + className + "Count\" resultType=\"int\" parameterType=\""+packageStr+".model." + className + "Query\">");
        xml.append("\nselect count(1) from " + tableName);
        xml.append("\n<include refid=\"" + className + "Condition\" />");
        xml.append("\n</select>\n\n");

        // xml bottom
        xml.append("\n\n</mapper>");

        try {
            FileUtils.writeStringToFile(new File(baseDir + "orm/"+className + ".xml"), xml.toString());
        } catch (IOException e) {
            e.printStackTrace();
        }

        // dao interface
        mapper.append("package "+packageStr + ".dao;\n" +
                "\n" +
                "import "+packageStr+".model."+className+";\n" +
                "import "+packageStr+".model."+className+"Query;\n" +
                "\n" +
                "import java.util.List;\n" +
                "\n" +
                "public interface "+className+"Mapper {");
        mapper.append("public void add" + className + "(" + className + " obj);");
        mapper.append("public void update" + className + "(" + className + " obj);");
        mapper.append("public void delete" + className + " (Integer id);");
        mapper.append("public " + className + " get" + className + " (Integer id);");
        mapper.append("public int query" + className + "Count (" + className + "Query query);");
        mapper.append("public List<" + className + "> query" + className + " (" + className + "Query query);\n\n");
        mapper.append("}");

        try {
            FileUtils.writeStringToFile(new File(baseDir+"dao/"+className+"Mapper.java"), mapper.toString());
            FileUtils.writeStringToFile(new File(baseDir+"service/"+className+"Service.java"), mapper.toString().replace("interface " + className + "Mapper", "interface " + className + "Service").replace("package "+packageStr + ".dao", "package "+packageStr + ".service"));
        } catch (IOException e) {
            e.printStackTrace();
        }


        // pojo
        pojo.append("package "+packageStr+".model;");
        pojo.append("\n\nimport java.util.Date;");
        pojo.append("\n\npublic class "+className+" {");
        for (int i = 0; i < list.size(); i++) {
            TableInfo ti = list.get(i);
            pojo.append("private " + ti.javatype + " " + ti.javacloumn + ";");
        }
        for (int i = 0; i < list.size(); i++) {
            TableInfo ti = list.get(i);
            pojo.append("\n\npublic "+ti.javatype+" get"+ti.javacloumn1+"() {\n" +
                    "        return "+ ti.javacloumn +";\n" +
                    "    }\n" +
                    "\n" +
                    "\n\n    public void set"+ti.javacloumn1+"("+ti.javatype+" "+ti.javacloumn+") {\n" +
                    "        this."+ ti.javacloumn +" = "+ ti.javacloumn +";\n" +
                    "\n    }");
        }
        pojo.append("\n}");

        try {
            FileUtils.writeStringToFile(new File(baseDir+"model/"+className+".java"), pojo.toString());
            FileUtils.writeStringToFile(new File(baseDir+"model/"+className+"Query.java"), pojo.toString().replace("class " + className, "class " + className + "Query extends BaseQuery").replace("import java.util.Date;", "\n\nimport java.util.Date;\nimport com.lymsh.mommybaby.basecommon.base.BaseQuery;\n\n"));
        } catch (IOException e) {
            e.printStackTrace();
        }

        String lowerClassName = className.substring(0, 1).toLowerCase() + className.substring(1);

        // service impl
        impl.append("package "+packageStr+".service.impl;\n" +
                "\n" +
                "import "+packageStr+".dao."+className+"Mapper;\n" +
                "import "+packageStr+".model."+className+";\n" +
                "import "+packageStr+".model."+className+"Query;\n" +
                "import "+packageStr+".service."+className+"Service;\n" +
                "import org.springframework.beans.factory.annotation.Autowired;\n" +
                "import org.springframework.stereotype.Service;\n" +
                "\n" +
                "import java.util.Date;\n" +
                "import java.util.List;\n" +
                "\n" +
                "@Service\n" +
                "public class "+className+"ServiceImpl implements "+className+"Service {\n");
        impl.append("\n@Autowired\n");
        impl.append("private " + className + "Mapper " + lowerClassName + "Mapper;\n");
        impl.append("\n@Override\n");
        impl.append("public void add" + className + "(" + className + " obj){" + lowerClassName + "Mapper." + "add" + className + "(obj);}");
        impl.append("\n@Override\n");
        impl.append("public void update" + className + "(" + className + " obj){" + lowerClassName + "Mapper." + "update" + className + "(obj);}");
        impl.append("\n@Override\n");
        impl.append("public void delete" + className + " (Integer id){" + lowerClassName + "Mapper." + "delete" + className + "(id);}");
        impl.append("\n@Override\n");
        impl.append("public " + className + " get" + className + " (Integer id){return " + lowerClassName + "Mapper." + "get" + className + "(id);}");
        impl.append("\n@Override\n");
        impl.append("public int query" + className + "Count (" + className + "Query query){return " + lowerClassName + "Mapper." + "query" + className + "Count(query);}");
        impl.append("\n@Override\n");
        impl.append("public List<" + className + "> query" + className + " (" + className + "Query query){if (query.getNeed() != null) {query.mysqlBuild(" + lowerClassName + "Mapper.query" + className + "Count(query));}return " + lowerClassName + "Mapper." + "query" + className + "(query);}\n\n");
        impl.append("}");

        try {
            FileUtils.writeStringToFile(new File(baseDir+"service/impl/"+className+"ServiceImpl.java"), impl.toString());
        } catch (IOException e) {
            e.printStackTrace();
        }

    }

    public List<TableInfo> execute(String tableName) {
        List<TableInfo> list = new ArrayList<TableInfo>();
        try {
            Class.forName("com.mysql.jdbc.Driver");
            Connection conn = DriverManager.getConnection(url, username, password);
            PreparedStatement pst = conn.prepareStatement("desc `" + tableName + "`");
            ResultSet rs = pst.executeQuery();
            while (rs.next()) {
                TableInfo ti = new TableInfo();
                ti.dbcolumn = rs.getString(1);
                ti.dbtype = rs.getString(2);
                ti.auto = rs.getString(6);
                list.add(ti);
            }
            rs.close();
            pst.close();
            conn.close();
        } catch (Exception e) {
            e.printStackTrace();
        } finally {
            return list;
        }
    }

    public List<TableInfo> build(List<TableInfo> list) {
        for (TableInfo ti : list) {
            if (ti.dbtype.startsWith("int") || ti.dbtype.startsWith("tinyint") || ti.dbtype.startsWith("smallint") || ti.dbtype.startsWith("mediumint")
                    || ti.dbtype.startsWith("bigint")) {
                ti.javatype = "Integer";
                ti.ibatistype = "INTEGER";
            } else if (ti.dbtype.startsWith("char") || ti.dbtype.startsWith("varchar") || ti.dbtype.startsWith("text") || ti.dbtype.startsWith("tinytext")
                    || ti.dbtype.startsWith("mediumtext") || ti.dbtype.startsWith("longtext")) {
                ti.javatype = "String";
                ti.ibatistype = "VARCHAR";
            } else if (ti.dbtype.startsWith("datetime")) {
                ti.javatype = "Date";
                ti.ibatistype = "TIMESTAMP";
            } else if (ti.dbtype.startsWith("double")) {
                ti.javatype = "Double";
                ti.ibatistype = "DOUBLE";
            }
            String[] array = ti.dbcolumn.split("_");
            ti.javacloumn = array[0];
            ti.javacloumn1 = "";
            if (array.length >= 2) {
                for (int i = 1; i < array.length; i++) {
                    ti.javacloumn += array[i].substring(0, 1).toUpperCase() + array[i].substring(1).toLowerCase();
                }
            }
            for (int i = 0; i < array.length; i++) {
                ti.javacloumn1 += array[i].substring(0, 1).toUpperCase() + array[i].substring(1).toLowerCase();
            }
        }
        return list;
    }

    class TableInfo {
        public String dbcolumn;
        public String dbtype;
        public String auto;
        public String javatype;
        public String javacloumn;
        public String javacloumn1;
        public String ibatistype;
    }
}
