package com.lymsh.yimiao.main.data.util;

import cn.jpush.api.push.model.Platform;
import cn.jpush.api.push.model.PushPayload;
import cn.jpush.api.push.model.audience.Audience;
import cn.jpush.api.push.model.notification.IosNotification;
import cn.jpush.api.push.model.notification.Notification;
import org.springframework.stereotype.Service;

/**
 * Created by Administrator on 2016/5/25 0025.
 */
@Service
public class JPushUtil {

    /**
     *  ios平台
     *  alias   别名
     *  alert   内容
     * @return
     */
    public static PushPayload buildPushObjectAllAliasAlertIos(String alias,String alert) {
        return PushPayload.newBuilder()
                .setPlatform(Platform.ios())
                .setAudience(Audience.alias(alias))
                .setNotification(Notification.newBuilder()
                        .addPlatformNotification(IosNotification.newBuilder()
                                .setAlert(alert)
                                .setBadge(1)
                                .build())
                        .build())
                .build();
    }

    public static PushPayload buildPushObjectAllAliasAlertAndroid(String alias,String alert) {
        return PushPayload.newBuilder()
                .setPlatform(Platform.android())
                .setAudience(Audience.alias(alias))
                .setNotification(Notification.alert(alert))
                .build();
    }


}
