package com.lymsh.yimiao.main.data.util;

import org.apache.commons.httpclient.HttpClient;
import org.apache.commons.httpclient.NameValuePair;
import org.apache.commons.httpclient.methods.GetMethod;
import org.apache.commons.httpclient.methods.PostMethod;

import java.security.MessageDigest;
import java.security.NoSuchAlgorithmException;

public class LoginUtil {

    public static LoginContext register(String phone, String token, String typeId) {
        HttpClient client = new HttpClient();
        PostMethod post = new MessageUtil.UTF8PostMethod("http://passport.healthbaby.com.cn/v1/register.action");
        NameValuePair[] data = {
                new NameValuePair("phone", phone),
                new NameValuePair("typeId", typeId),
        };
        post.setRequestBody(data);
        post.setRequestHeader("Authorization", token);

        LoginContext loginContext = new LoginContext();

        try {
            client.executeMethod(post);
            int statusCode = post.getStatusCode();
            String result = new String(post.getResponseBodyAsString());
            post.releaseConnection();
            if(200 == statusCode) {
                loginContext = JsonUtil.str2Obj(result, LoginContext.class);

                if (0 == loginContext.getErrorcode()) {
                    return loginContext;
                }
            }
        } catch (Exception e) {
            e.printStackTrace();
        }
        return loginContext;
    }


    public static LoginContext login(String phone, String varCode, String typeId, String token) {
        HttpClient client = new HttpClient();
        PostMethod post = new MessageUtil.UTF8PostMethod("http://passport.healthbaby.com.cn/v1/login.action");
        NameValuePair[] data = {
                new NameValuePair("phone", phone),
                new NameValuePair("typeId", typeId),
                new NameValuePair("code", varCode)
        };
        post.setRequestBody(data);
        post.setRequestHeader("Authorization", token);

        LoginContext loginContext = new LoginContext();

        try {
            client.executeMethod(post);
            int statusCode = post.getStatusCode();
            String result = new String(post.getResponseBodyAsString());
            System.out.println("result:" + result);
            post.releaseConnection();
            if (200 == statusCode) {
                loginContext = JsonUtil.str2Obj(result, LoginContext.class);

                System.out.println("loginState.getErrorcode() :" + loginContext.getErrorcode());

                if (0 == loginContext.getErrorcode()) {
                    return loginContext;
                }
            }
        } catch (Exception e) {
            e.printStackTrace();
        }
        return loginContext;
    }

    public static boolean sendVerCode(String phone, String typeId, String token) {
        HttpClient client = new HttpClient();
        //String query = "?phone=" + phone + "&typeId=" + typeId + "&token=" + token + "&userType=1";
        GetMethod get = new MessageUtil.UTF8GetMethod("http://passport.healthbaby.com.cn/v1/vercode.action");
        NameValuePair[] data = {
                new NameValuePair("phone", phone),
                new NameValuePair("typeId", typeId),
                new NameValuePair("userType", "1"),
        };
        get.setQueryString(data);
        get.setRequestHeader("Authorization", token);
        try {
            client.executeMethod(get);
            int statusCode = get.getStatusCode();
            System.out.println("statusCode:" + statusCode);
            String result = new String(get.getResponseBodyAsString());
            System.out.println("result:" + result);
            get.releaseConnection();
            if (result != null && result.indexOf("成功") > 0) {
                return true;
            }
        } catch (Exception e) {
            e.printStackTrace();
        }
        return false;
    }

    /**
     *  阿里大鱼
     * @param phone
     * @param typeId
     * @param token
     * @return
     */
    public static LoginContext sendCode(String phone, String typeId, String token) {

        LoginContext loginState = new LoginContext();

        HttpClient client = new HttpClient();
        GetMethod get = new MessageUtil.UTF8GetMethod("http://passport.healthbaby.com.cn/v1/authCode.action");
        NameValuePair[] data = {
                new NameValuePair("phone", phone),
                new NameValuePair("typeId", typeId),
        };
        get.setQueryString(data);
        get.setRequestHeader("Authorization", token);
        try {
            client.executeMethod(get);
            int statusCode = get.getStatusCode();
            System.out.println("statusCode:" + statusCode);
            String result = new String(get.getResponseBodyAsString());
            System.out.println("result:" + result);
            get.releaseConnection();
            if (result != null && result.indexOf("成功") > 0) {
                loginState = JsonUtil.str2Obj(result, LoginContext.class);
                return loginState;
            }
        } catch (Exception e) {
            e.printStackTrace();
        }
        return loginState;
    }



    public static LoginContext checkLoginState(String token) {
        LoginContext loginState = new LoginContext();
        HttpClient client = new HttpClient();
        String query = "?token=" + token ;
        GetMethod get = new MessageUtil.UTF8GetMethod("http://passport.healthbaby.com.cn/v1/check.action" + query);
        get.setRequestHeader("Authorization", token);
        try {
            client.executeMethod(get);
            int statusCode = get.getStatusCode();
            String result = new String(get.getResponseBodyAsString());
            get.releaseConnection();
            if(200 == statusCode) {
                loginState = JsonUtil.str2Obj(result, LoginContext.class);
                return loginState;
            }
        } catch (Exception e) {
            e.printStackTrace();
        }
        return loginState;
    }




    public static String md5(String plainText) {
        try {
            if(plainText==null){
                return null;
            }
            MessageDigest md = MessageDigest.getInstance("MD5");
            md.update(plainText.getBytes());
            byte b[] = md.digest();
            int i;
            StringBuffer buf = new StringBuffer("");
            for (int offset = 0; offset < b.length; offset++) {
                i = b[offset];
                if (i < 0)
                    i += 256;
                if (i < 16)
                    buf.append("0");
                buf.append(Integer.toHexString(i));
            }
            return buf.toString().toUpperCase();
        } catch (NoSuchAlgorithmException e) {
            e.printStackTrace();
            return null;
        }
    }
//
//    public static void main(String[] args) {
//        System.out.println(md5("123789456"));
//        String a = "{\"id\":20,\"token\":\"ucefac93386a4c70a8a570da5bbfc24ad0\",\"errormsg\":\"成功\",\"errorcode\":3}";
//
//
//        System.out.println(a.matches(".*errorcode\":0.*"));
//
//        Pattern pattern = Pattern.compile("token\":\"(.*?)\"");
//        Matcher matcher = pattern.matcher(a);
//        while(matcher.find()) {
//            System.out.println(matcher.group(1));
//        }
//
//        //3949ba59abbe56e057f20f88
//    }

}
