package com.lyms.yimiao.web.controller.v1;

import com.lymsh.mommybaby.basecommon.base.BaseController;
import com.lymsh.mommybaby.basecommon.base.TokenRequired;
import com.lymsh.mommybaby.basecommon.util.JsonUtil;
import com.lymsh.yimiao.main.data.util.ArticleContext;
import com.lymsh.yimiao.main.data.util.ArticleUtil;
import org.springframework.stereotype.Controller;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestMethod;
import org.springframework.web.bind.annotation.RequestParam;
import org.springframework.web.servlet.ModelAndView;

import javax.servlet.http.HttpServletResponse;

/**
 * Created by Administrator on 2016/5/12 0012.
 */

@Controller
@RequestMapping("/v1")
public class ArticleController extends BaseController{

    //幻灯片
    @RequestMapping(value = "/image/slide", method = RequestMethod.GET)
    @TokenRequired
    public void getSlide(HttpServletResponse response){
        writeJson(response, JsonUtil.obj2JsonString(ArticleUtil.getArticlesImages()));
    }

    //获取育儿课堂栏目
    @RequestMapping(value = "/category", method = RequestMethod.GET)
    @TokenRequired
    public void getCategory(HttpServletResponse response){
        writeJson(response, JsonUtil.obj2JsonString(ArticleUtil.getCategory()));
    }

    //获取文章列表
    @RequestMapping(value = "/article", method = RequestMethod.GET)
    @TokenRequired
    public void getArticles(HttpServletResponse response,
                    @RequestParam("categoryId")Integer categoryId,
                    @RequestParam("page")Integer page,
                    @RequestParam("limit")Integer limit){
        writeJson(response, JsonUtil.obj2JsonString(ArticleUtil.getArticles(categoryId, page, limit)));
    }

    //获取文章
    @RequestMapping(value = "/getArticle")
    public ModelAndView getArticles(HttpServletResponse response,
                            @RequestParam("id")Integer id){
        ModelAndView mv = new ModelAndView("error");

        if (id == null) {
            mv.addObject("msg", "vaccineNames id is null");
        }

        ArticleContext articleContext = ArticleUtil.getArticles(id);
        if (articleContext==null){
            mv.setViewName("empty");
            mv.addObject("msg", "无疫苗详情信息");
        }
        mv.setViewName("article");
        mv.addObject("articleContext", articleContext);
        return mv;
    }
}
