package com.lyms.yimiao.web.controller.v1;

import com.lymsh.mommybaby.basecommon.base.BaseController;
import com.lymsh.mommybaby.basecommon.bean.AppVersion;
import com.lymsh.mommybaby.basecommon.constant.ConstantInterface;
import com.lymsh.mommybaby.basecommon.util.QiniuUtil;
import com.lymsh.yimiao.main.data.util.JsonUtil;
import org.springframework.stereotype.Controller;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestMethod;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import java.util.HashMap;
import java.util.Map;

/**
 *  获取配置信息
 *
 * Created by Administrator on 2016/5/2 0002.
 */

@Controller
@RequestMapping("/v1")
public class ConfigController extends BaseController{

    /**
     *  IOS版本配置信息
     */
    @RequestMapping(value = "/iosConfigs", method = RequestMethod.GET)
    public void getIosConfig(HttpServletResponse response) {
        AppVersion version = new AppVersion(100, "1.0.0", "当前为最新版本","");
        Map<String, Object> map = new HashMap<>();
        map.put("version", version);
        map.put("errorcode", ConstantInterface.SUCCESS);
        map.put("errormsg", "成功");
        writeJson(response, JsonUtil.obj2JsonString(map));
    }


    /**
     *  Android版本配置信息
     */
    @RequestMapping(value = "/androidConfigs", method = RequestMethod.GET)
    public void getAndroidConfig(HttpServletResponse response) {
        AppVersion version = new AppVersion(100, "1.0.0", "当前为最新版本","");
        Map<String, Object> map = new HashMap<>();
        map.put("version", version);
        map.put("errorcode", ConstantInterface.SUCCESS);
        map.put("errormsg", "成功");
        writeJson(response, JsonUtil.obj2JsonString(map));
    }

    /**
     * 获取七牛图片上传token
     */
    @RequestMapping(value = "/tokens/qiniu", method = RequestMethod.GET)
    public void getQiniuToken(HttpServletResponse httpServletResponse) {
        Map<String, Object> map = new HashMap<String, Object>();
        map.put("upToken", QiniuUtil.getQiniuUtil().getUpToken());
        map.put("errorcode", ConstantInterface.SUCCESS);
        map.put("errormsg", "成功");
        writeJson(httpServletResponse, com.lymsh.mommybaby.basecommon.util.JsonUtil.obj2JsonString(map));
    }


}
