package com.lyms.yimiao.web.controller.v1;

import com.lymsh.mommybaby.basecommon.base.BaseController;
import com.lymsh.mommybaby.basecommon.base.TokenRequired;
import com.lymsh.mommybaby.basecommon.constant.ConstantInterface;
import com.lymsh.mommybaby.basecommon.context.MommyBobyContext;
import com.lymsh.mommybaby.basecommon.util.ContextHolder;
import com.lymsh.mommybaby.basecommon.util.ResultUtils;
import com.lymsh.yimiao.main.data.enumdata.YnEnum;
import com.lymsh.yimiao.main.data.model.YmFeedBacks;
import com.lymsh.yimiao.main.data.model.YmUsers;
import com.lymsh.yimiao.main.data.service.YmFeedBacksService;
import com.lymsh.yimiao.main.data.service.YmUsersService;
import com.lymsh.yimiao.main.data.util.FeedBackUtil;
import com.lymsh.yimiao.main.data.util.JsonUtil;
import com.lymsh.yimiao.main.data.util.LoginContext;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Controller;
import org.springframework.util.StringUtils;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestMethod;
import org.springframework.web.bind.annotation.RequestParam;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import java.util.Date;
import java.util.HashMap;
import java.util.Map;

/**
 *      反馈接口
 *
 * Created by Administrator on 2016/4/29 0029.
 */
@Controller
@RequestMapping("/v1")
public class FeedbackController extends BaseController{

    @Autowired
    private YmUsersService usersService;
    @Autowired
    private YmFeedBacksService feedBacksService;

    /**
     * 提交意见反馈
     *
     * @return
     */
    @RequestMapping(value = "/feedbacks", method = RequestMethod.POST)
    @TokenRequired
    public void submitFeedBack(@RequestParam("content") String content,
                               HttpServletRequest request,
                               HttpServletResponse httpServletResponse) {

        if (StringUtils.isEmpty(content)) {
            ResultUtils.buildParameterErrorResultAndWrite(httpServletResponse);
            return;
        }

        LoginContext loginContext = (LoginContext) request.getAttribute("loginContext");
        Integer userId = loginContext.getId();
        if (null != userId) {

            YmFeedBacks feedBacks = new YmFeedBacks();
            feedBacks.setYn(YnEnum.yes.getId());
            feedBacks.setCreated(new Date());
            feedBacks.setType(1);//默认是反馈
            feedBacks.setContent(content);
            feedBacks.setPublishId(userId);

            YmUsers users = usersService.getYmUsers(userId);
            if (null != users) {
                feedBacks.setPublishName(users.getNickname());
            }
            feedBacksService.addYmFeedBacks(feedBacks);
            ResultUtils.buildSuccessResultAndWrite(httpServletResponse);
        } else {
            Map<String, Object> result = new HashMap<>();
            result.put("errorcode", ConstantInterface.SYSTEM_ERROR);
            result.put("errormsg", "userId为空.");
            writeJson(httpServletResponse, JsonUtil.obj2JsonString(result));
        }
    }

    //反馈
    @RequestMapping(value = "/ams/feedbacks", method = RequestMethod.POST)
    @TokenRequired
    public void sendFeedBack(HttpServletResponse response,
                             HttpServletRequest request,
                             @RequestParam("content") String content) {
        if (StringUtils.isEmpty(content)) {
            ResultUtils.buildParameterErrorResultAndWrite(response);
            return;
        }

        LoginContext loginContext = (LoginContext) request.getAttribute("loginContext");
        Integer userId = loginContext.getId();
        if (null != userId) {
            YmUsers users = usersService.getYmUsers(userId);
            boolean result = FeedBackUtil.sendFeedBack(content,users.getNickname()==null ? users.getPhone() : users.getNickname());
            if (result){
                ResultUtils.buildSuccessResultAndWrite(response);
            }else {
                ResultUtils.buildParameterErrorResultAndWrite(response,"发送反馈信息失败");
            }
        }else {
            ResultUtils.buildParameterErrorResultAndWrite(response,"登录异常");
        }
    }


}
