package com.lyms.yimiao.web.controller.v1;

import com.lymsh.mommybaby.basecommon.base.TokenRequired;
import com.lymsh.yimiao.main.data.enumdata.PositionEnum;
import com.lymsh.yimiao.main.data.model.*;
import com.lymsh.yimiao.main.data.service.*;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Controller;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestParam;
import org.springframework.web.servlet.ModelAndView;

import javax.servlet.http.HttpServletResponse;
import java.text.SimpleDateFormat;
import java.util.*;

/**
 * Created by Administrator on 2016/5/13 0013.
 */
@Controller
@RequestMapping("/v1")
public class InoculateRecordController {
    @Autowired
    private MedInoculateRecordService medInoculateRecordService;
    @Autowired
    private MedFactoryService medFactoryService;
    @Autowired
    private MedVaccineInfoService medVaccineinfoService;
    @Autowired
    private MedOrganizationService medOrganizationService;
    @Autowired
    private MedEmployeeService medEmployeeService;
    @Autowired
    private MedVaccineNameService medVaccineNameService;

    private final static String isDelete = "1";

    /**
     * 获取接种记录
     *
     * @param response
     */
    @RequestMapping(value = "/getInoculateRecord")
    public ModelAndView getKidVaccines(HttpServletResponse response,
                               @RequestParam("id") String icId) {
        ModelAndView mv = new ModelAndView("error");

        if (icId == null) {
            mv.addObject("msg", "inoculateRecord id is null");
        }
        MedInoculateRecordQuery recordQuery = new MedInoculateRecordQuery();
        recordQuery.setIcId(icId);
        recordQuery.setIsDelete(isDelete);
        List<MedInoculateRecord> recordList = medInoculateRecordService.queryMedInoculateRecord(recordQuery);
        if (recordList.size()==0){
            mv.setViewName("empty");
            mv.addObject("msg", "无接种记录信息");
        }
        MedInoculateRecord data = recordList.get(0);
        //疫苗名称
        MedVaccineInfo info = medVaccineinfoService.getMedVaccineInfo(data.getIcVaccineId());
        data.setIcVaccineId(info==null ? "" : info.getViName());
        //生产企业
        if (info!=null){
            if (info.getViFactoryId()!= null){
                MedFactory medFactory = medFactoryService.getMedFactory(info.getViFactoryId());
                data.setIcFactoryName(medFactory == null ? "" : medFactory.getFName());
            }

            //疫苗详情

            //疫苗名称
            if (info.getViVaccineNameId()!=null){
                MedVaccineName medVaccineName = medVaccineNameService.getMedVaccineName(info.getViVaccineNameId());
                data.setVnName(medVaccineName==null ? "" : medVaccineName.getVnName());
                //接种时间
                String[] ages = medVaccineName.getVnMonthAge().split(",");//1,2

                //接种次数
                String jiCi = "第" + data.getIcJiCi() +"/" + ages.length +"剂";
                data.setIcJiCi(jiCi);

                String monthAgeStr = "";
                for (int j = 0; j < ages.length ; j++) {
                    String q = ages[j]+"月龄"+"("+ (j+1) +"/"+ages.length+")";
                    monthAgeStr+=q;
                    if (ages.length-1 != j)
                    {
                        monthAgeStr+=",";
                    }
                }
                data.setMouthAge(monthAgeStr);

                //接种部位
                if (medVaccineName.getVnPosition().equals(PositionEnum.zero.getId())){
                    data.setVnPosition(PositionEnum.getTitle(PositionEnum.zero.getId()));
                }else if (medVaccineName.getVnPosition().equals(PositionEnum.one.getId())) {
                    data.setVnPosition(PositionEnum.getTitle(PositionEnum.one.getId()));
                } else if (medVaccineName.getVnPosition().equals(PositionEnum.two.getId())) {
                    data.setVnPosition(PositionEnum.getTitle(PositionEnum.two.getId()));
                } else if (medVaccineName.getVnPosition().equals(PositionEnum.three.getId())) {
                    data.setVnPosition(PositionEnum.getTitle(PositionEnum.three.getId()));
                } else if (medVaccineName.getVnPosition().equals(PositionEnum.four.getId())) {
                    data.setVnPosition(PositionEnum.getTitle(PositionEnum.four.getId()));
                } else if (medVaccineName.getVnPosition().equals(PositionEnum.five.getId())) {
                    data.setVnPosition(PositionEnum.getTitle(PositionEnum.five.getId()));
                }
                //接种禁忌
                data.setVnTaboo(medVaccineName.getVnTaboo());
                //不良反应
                data.setVnDescription(medVaccineName.getVnDescription());
            }
        }
        //医生名字
        if (data.getIcDoctor()!=null){
            MedEmployee employee = medEmployeeService.getMedEmployee(data.getIcDoctor());
            data.setIcDoctor(employee==null ? "" : employee.getEName());
        }

        //接种日期
        try {
            Date d1 = new SimpleDateFormat("yyyy-MM-dd").parse(data.getIcInoculateTime());
            SimpleDateFormat simpleDateFormat = new SimpleDateFormat("yyyy年MM月dd日");
            String icInoculateTime = simpleDateFormat.format(d1);
            data.setIcInoculateTime(icInoculateTime);
        }catch (Exception e){

        }
        //接种单位
        MedOrganization medOrganization = medOrganizationService.getMedOrganization(data.getIcOrganizationId());
        data.setIcOrganizationId(medOrganization==null ? "" : medOrganization.getoName());
        mv.setViewName("inoculateRecord");
        mv.addObject("recordObj", data);







        return mv;

    }

}
