package com.lyms.yimiao.web.controller.v1;

import com.lymsh.mommybaby.basecommon.base.BaseController;
import com.lymsh.mommybaby.basecommon.base.TokenRequired;
import com.lymsh.mommybaby.basecommon.cache.redis.RedisUtils;
import com.lymsh.mommybaby.basecommon.constant.ConstantInterface;
import com.lymsh.mommybaby.basecommon.util.DateUtil;
import com.lymsh.mommybaby.basecommon.util.ResultUtils;
import com.lymsh.yimiao.main.data.enumdata.MouthAgeEnum;
import com.lymsh.yimiao.main.data.enumdata.YnEnum;
import com.lymsh.yimiao.main.data.model.*;
import com.lymsh.yimiao.main.data.service.*;
import com.lymsh.yimiao.main.data.util.JsonUtil;
import com.lymsh.yimiao.main.data.util.LoginContext;
import com.lymsh.yimiao.main.data.util.VaccineNameSington;
import org.apache.commons.collections.CollectionUtils;
import org.apache.commons.lang.StringUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.beans.factory.annotation.Value;
import org.springframework.http.MediaType;
import org.springframework.stereotype.Controller;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestMethod;
import org.springframework.web.bind.annotation.RequestParam;


import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import java.util.*;

/**
 * 宝宝接口
 * <p/>
 * Created by Administrator on 2016/4/28 0028.
 */
@Controller
@RequestMapping("/v1")
public class KidsController extends BaseController {

    @Value("#{configProperties['yimiao.token']}")
    private String token;
    @Value("#{configProperties['yimiao.typeId']}")
    private String typeId;

    @Autowired
    private MedKidsService medKidsService;
    @Autowired
    private YmUsersService usersService;
    @Autowired
    private YmUserKidMapsService ymUserKidMapsService;
    @Autowired
    private MedInoculateOrderService medInoculateorderService;

    @Autowired
    private MedOrganizationService medOrganizationService;
    @Autowired
    private MedVaccineNameService medVaccineNameService;


    private final static String isDelete = "1";

    @Autowired
    private VaccineNameSington vaccineNameSington;

//    /**
//     * 发送验证码
//     * @param response
//     * @param phone     手机号
//     */
//    @RequestMapping(value = "/sendCode", method = RequestMethod.GET, produces = MediaType.APPLICATION_JSON_VALUE + ";charset=utf-8")
//    @TokenRequired
//    public void sendVercode(HttpServletResponse response,@RequestParam("phone") String phone) {
//
//        if (StringUtils.isNotBlank(phone)){
//            //对手机号是否存在做校验
//            MedKidsQuery query = new MedKidsQuery();
//            query.setPhone(phone);
//            List<MedKids> medKidsList = medKidsService.queryMedKids(query);
//            if (medKidsList.size()==0){
//                ResultUtils.buildParameterErrorResultAndWrite(response,"您预留的手机号不存在,请重新输入");
//                return;
//            }
//
//            Boolean result = LoginUtil.sendVerCode(phone, typeId, token);
//            if (result){
//                ResultUtils.buildSuccessResultAndWrite(response);
//            }else {
//                ResultUtils.buildParameterErrorResultAndWrite(response,"发送失败");
//            }
//        }
//    }

    /**
     * 校验验证码
     *
     * @param response
     * @param code     发送给用户的验证码
     */
    @RequestMapping(value = "/checkCode", method = RequestMethod.GET, produces = MediaType.APPLICATION_JSON_VALUE + ";charset=utf-8")
    @TokenRequired
    public void checkCode(HttpServletResponse response,
                          @RequestParam("phone") String phone,
                          @RequestParam("code") String code) {
        Map<String, Object> resultMsgMap = new HashMap<>();

        //测试需要
        if (code.equals("123456")){
            resultMsgMap.put("idRight", true);
            resultMsgMap.put(ResultUtils.ERROR_CODE, ConstantInterface.SUCCESS);
            resultMsgMap.put(ResultUtils.ERROR_MSG, "成功");
        }else {
            //通过手机拿到redis中的验证码,然后和用户输入的验证码做校验
            //从redis里面获取验证码
            Object verCodeObj = (Object) RedisUtils.getObj("c_" + phone);
            if (verCodeObj == null) {
                //参数错误
                resultMsgMap.put(ResultUtils.ERROR_CODE, ConstantInterface.VER_CODE_EXPIRE);
                resultMsgMap.put(ResultUtils.ERROR_MSG, "验证码错误");
                writeJson(response, JsonUtil.obj2JsonString(resultMsgMap));//把这个map转成一个json字符串输出到前台
                return;
            }
            if (code.equals(verCodeObj)) {
                resultMsgMap.put("idRight", true);
                resultMsgMap.put(ResultUtils.ERROR_CODE, ConstantInterface.SUCCESS);
                resultMsgMap.put(ResultUtils.ERROR_MSG, "成功");
            }else {
                resultMsgMap.put("idRight", false);
                resultMsgMap.put(ResultUtils.ERROR_CODE, ConstantInterface.USER_PASSWORD_ERROR);
                resultMsgMap.put(ResultUtils.ERROR_MSG, "验证码错误,请重新输入");
            }
        }
        writeJson(response, JsonUtil.obj2JsonString(resultMsgMap));
    }

    /**
     * 查询当前登陆账号所关联的宝宝,返回ID
     *
     * @param response
     * @param birthday
     * @param barCode
     * @param phone
     */
    @RequestMapping(value = "/queryKidsId", method = RequestMethod.GET, produces = MediaType.APPLICATION_JSON_VALUE + ";charset=utf-8")
    @TokenRequired
    public void getKidsId(HttpServletResponse response,
                          HttpServletRequest request,
                          @RequestParam("birthday") String birthday,
                          @RequestParam(value = "barCode", required = false) String barCode,
                          @RequestParam(value = "phone", required = false) String phone) {

        LoginContext loginContext = (LoginContext) request.getAttribute("loginContext");
        //取到当前登陆用户的id
        YmUsers users = usersService.getYmUsers(loginContext.getId());

        MedKidsQuery medKidsQuery = new MedKidsQuery();
        medKidsQuery.setBirthday(birthday);
        if (StringUtils.isNotEmpty(barCode)){
            //去掉前后空白
            medKidsQuery.setBarCode(barCode.trim());
        }
        medKidsQuery.setPhone(phone);
        medKidsQuery.setSort("ki_buildtime desc");//时间排序
        medKidsQuery.setIsDelete(isDelete);
        List<MedKids> medKidsList = medKidsService.queryMedKids(medKidsQuery);

        List<Map> list = new ArrayList<>();

        if (CollectionUtils.isNotEmpty(medKidsList)) {

            for (MedKids medKids : medKidsList) {

                Map<String, Object> map = new HashMap<>();

                YmUserKidMapsQuery query = new YmUserKidMapsQuery();
                query.setYn(YnEnum.yes.getId());
                query.setKidId(medKids.getId());
                query.setUserId(users.getId());
                int count = ymUserKidMapsService.queryYmUserKidMapsCount(query);
                if (StringUtils.isNotEmpty(medKids.getName())) {
                    if (count > 0){
                        map.put("relate",true);
                    }else if (count == 0){
                        map.put("relate",false);
                    }
                    map.put("id", medKids.getId());
                    map.put("name", medKids.getName());
                    map.put("sex",medKids.getSex());
                }
                list.add(map);
            }
        }
        ResultUtils.buildSuccessResultAndWrite(response, list);

//            List<String> ids = null;
//
//            List<String> names = new ArrayList<>();
//            for (int i = 0; i < medKidsList.size(); i++) {
//                Map<String, String> map = new HashMap<>();
//
//                ids = new ArrayList<>();
//                if (names.contains(medKidsList.get(i).getName())) continue;
//
//                names.add(medKidsList.get(i).getName());
//
//                for (int j = 0; j < medKidsList.size(); j++) {
//                    String id = medKidsList.get(j).getId();
//                    if (!ids.contains(medKidsList.get(j).getId()) && i == j) {
//                        ids.add(id);
//                    }
//
//                    if (medKidsList.get(i).getName().equals(medKidsList.get(j).getName()) && i != j && !ids.contains(j)) {
//                        ids.add(id);
//                    }
//                }
//                String tmp = "";
//                for (String k : ids) {
//                    tmp += k + ",";
//                }
//                map.put("name", medKidsList.get(i).getName());
//                map.put("id", tmp.substring(0, tmp.length() - 1));
//
//                list.add(map);
//            }
//        }
//        ResultUtils.buildSuccessResultAndWrite(response, list);
    }

    /**
     * 添加宝宝接口(当前登陆用户与小孩子进行关联)
     *
     * @param response
     * @param id       宝宝id
     */
    @RequestMapping(value = "/babys", method = RequestMethod.POST)
    @TokenRequired
    public void UserRelateKids(HttpServletResponse response,
                               HttpServletRequest request,
                               @RequestParam("id") String id) {
        MedKids kids = medKidsService.getMedKids(id);
        if (kids == null) {
            ResultUtils.buildParameterErrorResultAndWrite(response, "宝宝id不存在");
            return;
        }
        //取到当前登陆用户的id
        LoginContext loginContext = (LoginContext) request.getAttribute("loginContext");
        YmUsers users = usersService.getYmUsers(loginContext.getId());
        //把查询到的宝宝id与登陆用户关联
        YmUserKidMapsQuery query = new YmUserKidMapsQuery();
        query.setUserId(users.getId());
        query.setKidId(id);
        query.setYn(YnEnum.yes.getId());
        int count = ymUserKidMapsService.queryYmUserKidMapsCount(query);
        if (count > 0) {
            //已经关联了的宝宝就不需要再关联,直接返回成功
            ResultUtils.buildSuccessResultAndWrite(response);
        }else {
            YmUserKidMaps userKidMaps = new YmUserKidMaps();
            userKidMaps.setUserId(users.getId());
            userKidMaps.setKidId(id);
            userKidMaps.setCreated(new Date());
            userKidMaps.setYn(YnEnum.yes.getId());
            ymUserKidMapsService.addYmUserKidMaps(userKidMaps);
            ResultUtils.buildSuccessResultAndWrite(response);
        }

    }

    /**
     * 获取宝宝信息
     *
     * @param response
     * @param id       宝宝id
     */
    @RequestMapping(value = "/babys", method = RequestMethod.GET)
    @TokenRequired
    public void getKids(HttpServletResponse response,
                        @RequestParam("id") String id) {
        if (StringUtils.isBlank(id)) {
            ResultUtils.buildIdIsNull(response);
            return;
        }

        Map<String, Object> map = new HashMap<>();

//        MedInoculateRecordQuery recordQuery = new MedInoculateRecordQuery();
//        recordQuery.setRecordKidId(id);
//        recordQuery.setSort("IC_INOCULATETIME desc");
//        List<KidInoculationRecords> recordsAsc = medKidsService.queryInoculationRecords(recordQuery);

        List<KidInoculationRecords> recordsList = medKidsService.queryInoculationRecord(id);

        if (CollectionUtils.isNotEmpty(recordsList)){
            //最后一次接种时间
            map.put("lastInculateTime",DateUtil.getSecond(DateUtil.parseYMDHMS(recordsList.get(0).getInoculateTime())));
        }else {
//            map.put("lastInculateTime","");
            map.put("lastInculateTime",null);
        }

        //取出建档最早的那个
        MedKidsQuery query = new MedKidsQuery();
        query.setIsDelete(isDelete);
        query.setId(id);
        query.setSort("KI_BUILDTIME DESC");
        List<MedKids> medKidList = medKidsService.queryMedKids(query);

        if (CollectionUtils.isNotEmpty(medKidList)) {
            //取出第一个宝宝
            MedKids kids = medKidList.get(0);

            map.put("id", kids.getId());
            map.put("name", kids.getName());
            map.put("sex",kids.getSex());
            map.put("birthday", DateUtil.getSecond(DateUtil.parseYMD(kids.getBirthday())));
            map.put("avatar", null);//先给默认头像

            //下次接种疫苗
            MedInoculateOrderQuery inoculateorderQuery = new MedInoculateOrderQuery();
            inoculateorderQuery.setIoKidId(kids.getId());
            inoculateorderQuery.setIoIsDelete(isDelete);
            List<MedInoculateOrder> inoculateorderList = medInoculateorderService.queryMedInoculateOrder(inoculateorderQuery);

            List<Map> list = new ArrayList<>();

            if (CollectionUtils.isNotEmpty(inoculateorderList)) {

                //接种地点
                MedInoculateOrder order = inoculateorderList.get(0);
                map.put("organizationId", order.getIoOrganizationId());
                MedOrganization medOrganization = medOrganizationService.getMedOrganization(order.getIoOrganizationId());
//                map.put("organizationName", medOrganization == null ? "" : medOrganization.getoName());
                map.put("organizationName", medOrganization == null ? null : medOrganization.getoName());

                for (MedInoculateOrder data : inoculateorderList){
                    Map<String, Object> orderMap = new HashMap<>();
                    //下次接种时间
                    orderMap.put("ioInoculateDate", DateUtil.getSecond(DateUtil.parseYMD(data.getIoInoculateDate())));
                    //下次接种疫苗ID
                    orderMap.put("vaccineId", data.getIoVaccineId());
                    //下次接种疫苗名称
                    MedVaccineName medVaccineName = medVaccineNameService.getMedVaccineName(data.getIoVaccineId());
//                    orderMap.put("vaccineName", medVaccineName == null ? "" : medVaccineName.getVnName());
                    orderMap.put("vaccineName", medVaccineName == null ? null : medVaccineName.getVnName());
                    //剂次
                    if (medVaccineName != null) {
                        //总针数
                        int sum = medVaccineName.getVnMonthAge().split(",").length;
                        //预约打第几针
                        int jiCi = 1;

                        if (CollectionUtils.isNotEmpty(recordsList)) {
                            for (KidInoculationRecords records : recordsList) {
                                if (data.getIoVaccineId().equals(records.getVaccineNameId())) {
                                    if (records.getJiCi() < sum) {
                                        jiCi = jiCi + records.getJiCi();
                                        break;
                                    }
                                }
                            }
                        }
                        orderMap.put("sum",sum);
                        orderMap.put("jiCi",jiCi);
                    }
                    list.add(orderMap);
                }
                map.put("inoculate",list);

            } else {
                map.put("organizationId", null);
                map.put("organizationName", null);
                Map<String, Object> orderMap = new HashMap<>();
                orderMap.put("ioInoculateDate", null);
                orderMap.put("vaccineId", null);
                orderMap.put("vaccineName", null);
//                orderMap.put("sum","");
                orderMap.put("sum",null);
//                orderMap.put("jiCi","");
                orderMap.put("jiCi",null);
                list.add(orderMap);
                map.put("inoculate",list);
            }
        } else {
            ResultUtils.buildParameterErrorResultAndWrite(response, "宝宝信息不存在");
        }
        map.put("errorcode", ConstantInterface.SUCCESS);
        map.put("errormsg", "成功");
        writeJson(response, JsonUtil.obj2JsonString(map));
    }

    public static void main(String[] str) {
        long a = DateUtil.getSecond(new Date()) - DateUtil.getSecond(DateUtil.parseYMD("2016-1-1"));

        System.out.println(DateUtil.getSecond(new Date()));
        System.out.println(DateUtil.parseYMD("2016-1-1"));

        System.out.print(a);
    }



    /**
     * 根据月龄获取宝宝该月龄预约接种的疫苗(分为免费疫苗和收费疫苗两个模块)
     *
     * @param response
     * @param kidId    宝宝ID
     */
    @RequestMapping(value = "/inoculatePlan", method = RequestMethod.GET)
    @TokenRequired
    public void getKidInoculatePlan(HttpServletResponse response,
                                    @RequestParam("id") String kidId) {
        List<MedVaccineName> nameList = vaccineNameSington.getListVaccineName();

        List<KidInoculationRecords> recordsList = medKidsService.queryInoculationRecord(kidId);

        List<Map> list = new ArrayList<>();//最外层的list

        int monthYear = 0;

        for (MouthAgeEnum ageEnum : MouthAgeEnum.values()) {

            Map<String, Object> map = new HashMap<>();

            Map<String, Object> mouthMap = new HashMap<>();//装免费和收费的map
            List<Map> mouthList = new ArrayList<>();//月龄的list
            List<Map> freeList = new ArrayList<>();
            List<Map> chargeList = new ArrayList<>();

            for (MedVaccineName data : nameList) {
                if (ageEnum.getId() == data.getMouthAge()) {
                    if (data.getVnVaccineType() == 1) {
                        Map<String, Object> freeMap = new HashMap<>();
                        freeMap.put("id", data.getVnId());
                        freeMap.put("title", data.getVnName());
                        String[] a = data.getVnMonthAge().split(",");
                        int sum = a.length;
                        int current = 0;
                        for (int i = 0; i < a.length; i++) {
                            if (data.getMouthAge() == Integer.valueOf(a[i])) {
                                current = i + 1;
                            }
                        }
                        freeMap.put("current", current);
                        freeMap.put("sum", sum);
                        //接种ID
                        if (CollectionUtils.isNotEmpty(recordsList)) {
                            for (KidInoculationRecords temp : recordsList) {
                                if (temp.getJiCi() == current && temp.getVaccineNameTitle().equals(data.getVnName())
                                        && temp.getVaccineType().equals("1")) {
                                    freeMap.put("inoculateId", temp.getRecordId());
                                    break;
                                } else {
                                    freeMap.put("inoculateId", null);
                                }
                            }
                        } else {
                            freeMap.put("inoculateId", null);
                        }
                        freeList.add(freeMap);
                    } else if (data.getVnVaccineType() == 2) {
                        Map<String, Object> chargeMap = new HashMap<>();
                        chargeMap.put("id", data.getVnId());
                        chargeMap.put("title", data.getVnName());
                        String[] a = data.getVnMonthAge().split(",");
                        int sum = a.length;
                        int current = 0;
                        for (int i = 0; i < a.length; i++) {
                            if (data.getMouthAge() == Integer.valueOf(a[i])) {
                                current = i + 1;
                            }
                        }
                        chargeMap.put("current", current);
                        chargeMap.put("sum", sum);
                        //接种ID
                        if (CollectionUtils.isNotEmpty(recordsList)) {
                            for (KidInoculationRecords temp : recordsList) {
                                if (temp.getJiCi() == current && temp.getVaccineNameTitle().equals(data.getVnName())
                                        && temp.getCnt() == sum && temp.getVaccineType().equals("2")) {
                                    chargeMap.put("inoculateId", temp.getRecordId());
                                    break;
                                } else {
                                    chargeMap.put("inoculateId", null);
                                }
                            }
                        } else {
                            chargeMap.put("inoculateId", null);
                        }
                        chargeList.add(chargeMap);
                    }
                }
            }
            monthYear = monthYear + 1;
            mouthMap.put("freeList", freeList);
            mouthMap.put("chargeList", chargeList);
            mouthList.add(mouthMap);
            map.put("monthsOfAge"+monthYear, mouthList);
            list.add(map);
        }

        ResultUtils.buildSuccessResultAndWrite(response, list);
    }




}
