package com.lyms.yimiao.web.controller.v1;

import com.lymsh.mommybaby.basecommon.base.BaseController;
import com.lymsh.mommybaby.basecommon.base.TokenRequired;
import com.lymsh.mommybaby.basecommon.bean.CommonResult;
import com.lymsh.mommybaby.basecommon.util.DateUtil;
import com.lymsh.mommybaby.basecommon.util.ResultUtils;
import com.lymsh.yimiao.main.data.enumdata.YnEnum;
import com.lymsh.yimiao.main.data.model.YmNotifications;
import com.lymsh.yimiao.main.data.model.YmNotificationsQuery;
import com.lymsh.yimiao.main.data.model.YmPushMessages;
import com.lymsh.yimiao.main.data.model.YmPushMessagesQuery;
import com.lymsh.yimiao.main.data.service.YmNotificationsService;
import com.lymsh.yimiao.main.data.service.YmPushMessagesService;
import com.lymsh.yimiao.main.data.util.LoginContext;
import org.apache.commons.collections.CollectionUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Controller;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestMethod;
import org.springframework.web.bind.annotation.RequestParam;

import javax.management.Notification;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import java.util.*;

/**
 *
 *      消息接口
 *
 * Created by Administrator on 2016/4/29 0029.
 */
@Controller
@RequestMapping("/v1")
public class NotificationsController extends BaseController{

    @Autowired
    private YmNotificationsService notificationsService;
    @Autowired
    private YmPushMessagesService ymPushMessagesService;

    //获取消息(1.系统消息2.接种消息)
    @RequestMapping(value = "/notifications", method = RequestMethod.GET)
    @TokenRequired
    public void getNotifications(HttpServletResponse response,
                                 HttpServletRequest request,
                                 @RequestParam("time") String time){
        //系统消息
        YmNotificationsQuery notificationsQuery = new YmNotificationsQuery();
        notificationsQuery.setYn(YnEnum.yes.getId());
        notificationsQuery.setSort("created desc");

        if (time==null){
            ResultUtils.buildParameterErrorResultAndWrite(response);
            return;
        }
        Long timeLong = Long.valueOf(time);

        notificationsQuery.setCreated(new Date(timeLong*1000));
        List<YmNotifications> notificationsList = notificationsService.queryYmNotifications(notificationsQuery);

        List<Map> list = new ArrayList<>();

        if (CollectionUtils.isNotEmpty(notificationsList)){
            for (YmNotifications data : notificationsList){
                Map<String,Object> map = new HashMap<>();
                map.put("id",data.getId());
                map.put("created", DateUtil.getSecond(data.getCreated()));
                map.put("type",1);
                map.put("content",data.getContent());
                list.add(map);
            }
        }

        //接种通知
//        List inculateList = getInculateList(request);
        List inculateList = getInculateList(request,timeLong);
        if (CollectionUtils.isNotEmpty(inculateList)){
            list.addAll(inculateList);
        }

        //对所有结果集重新排序
        Collections.sort(list, new Comparator<Map>() {
            private String key ="created";
            @Override
            public int compare(Map o1, Map o2) {
                if(o1.containsKey(key)&&o2.containsKey(key)){
                    if((Integer)o1.get(key)==(Integer)o2.get(key)){
                        return 0;
                    }
                    if((Integer)o1.get(key)>(Integer)o2.get(key)){
                        return -1;
                    }else{
                        return 1;
                    }
                }
                return 0;
            }
        });
        ResultUtils.buildSuccessResultAndWrite(response,list);
    }

    private List getInculateList(HttpServletRequest request,long time) {
        List<Map> dataList = new ArrayList<>();

        LoginContext loginContext = (LoginContext) request.getAttribute("loginContext");

        YmPushMessagesQuery query = new YmPushMessagesQuery();
        query.setYn(YnEnum.yes.getId());
        query.setReceptionId(loginContext.getId());
        query.setCreated(new Date(time * 1000));
        List<YmPushMessages> messagesList = ymPushMessagesService.queryYmPushMessages(query);
        if (CollectionUtils.isNotEmpty(messagesList)){
            for (YmPushMessages data : messagesList){
                Map<String,Object> map = new HashMap<>();
                map.put("id",data.getId());
                map.put("content",data.getContent());
                map.put("created",DateUtil.getSecond(data.getCreated()));
                map.put("type",2);
                dataList.add(map);
            }
        }
        return  dataList;
    }


}
