package com.lyms.yimiao.web.controller.v1;

import com.lymsh.mommybaby.basecommon.base.BaseController;
import com.lymsh.mommybaby.basecommon.constant.ConstantInterface;
import com.lymsh.mommybaby.basecommon.util.ResultUtils;
import com.lymsh.yimiao.main.data.model.MedOrganization;
import com.lymsh.yimiao.main.data.service.MedAreaService;
import com.lymsh.yimiao.main.data.service.MedOrganizationService;
import com.lymsh.yimiao.main.data.util.JsonUtil;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Controller;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestMethod;
import org.springframework.web.bind.annotation.RequestParam;

import javax.servlet.http.HttpServletResponse;
import java.util.HashMap;
import java.util.Map;

/**
 *      机构信息
 *
 * Created by Administrator on 2016/4/29 0029.
 */
@Controller
@RequestMapping("/v1")
public class OrganizationsController extends BaseController{

    @Autowired
    private MedOrganizationService medOrganizationService;
    @Autowired
    private MedAreaService medAreaService;


    @RequestMapping(value = "/organizations", method = RequestMethod.GET)
    public void getOrganizations(HttpServletResponse response,
                          @RequestParam("id") String id){

        MedOrganization medOrganization = medOrganizationService.getMedOrganization(id);
        if (medOrganization==null){
            ResultUtils.buildParameterErrorResultAndWrite(response,"单位ID为不存在");
            return;
        }
        Map<String,Object> map = new HashMap<>();
        map.put("name",medOrganization.getoName());
        map.put("contactWay",medOrganization.getoContactWay());
        //省
        if (medOrganization.getoProvinceNo()!=null){
            map.put("province",medAreaService.getMedArea(medOrganization.getoProvinceNo()) == null ? "" : medAreaService.getMedArea(medOrganization.getoProvinceNo()).getAName());
        }else {
            map.put("province",null);
        }
        //市
        if (medOrganization.getoCityNo()!=null){
            map.put("city",medAreaService.getMedArea(medOrganization.getoCityNo()) == null ? "" : medAreaService.getMedArea(medOrganization.getoCityNo()).getAName());
        }else {
            map.put("city",null);
        }
        //县
        if (medOrganization.getoCountyNo()!=null){
            map.put("county",medAreaService.getMedArea(medOrganization.getoCountyNo()) == null ? "" : medAreaService.getMedArea(medOrganization.getoCountyNo()).getAName());
        }else {
            map.put("county",null);
        }
        //乡镇
        if (medOrganization.getoTownshipNo()!=null){
            map.put("township",medAreaService.getMedArea(medOrganization.getoTownshipNo()) == null ? "" : medAreaService.getMedArea(medOrganization.getoTownshipNo()).getAName());
        }else {
            map.put("township",null);
        }
        //村
        if (medOrganization.getoVillageNo()!=null){
            map.put("village",medAreaService.getMedArea(medOrganization.getoVillageNo()) == null ? "" : medAreaService.getMedArea(medOrganization.getoVillageNo()).getAName());
        }else {
            map.put("village",null);
        }
        //街道
        if (medOrganization.getoAddress()!=null){
            map.put("address",medAreaService.getMedArea(medOrganization.getoAddress()) == null ? "" : medAreaService.getMedArea(medOrganization.getoAddress()).getAName());
        }else {
            map.put("address",null);
        }
        map.put("errorcode", ConstantInterface.SUCCESS);
        map.put("errormsg", "成功");
        writeJson(response, JsonUtil.obj2JsonString(map));

    }

}
