package com.lyms.yimiao.web.controller.v1;

import com.lymsh.mommybaby.basecommon.base.BaseController;
import com.lymsh.mommybaby.basecommon.base.TokenRequired;
import com.lymsh.mommybaby.basecommon.cache.redis.RedisUtils;
import com.lymsh.mommybaby.basecommon.constant.ConstantInterface;
import com.lymsh.mommybaby.basecommon.service.TokenService;
import com.lymsh.mommybaby.basecommon.util.ContextHolder;
import com.lymsh.mommybaby.basecommon.util.JsonUtil;
import com.lymsh.mommybaby.basecommon.util.QiniuUtil;
import com.lymsh.mommybaby.basecommon.util.ResultUtils;
import com.lymsh.yimiao.main.data.enumdata.YnEnum;
import com.lymsh.yimiao.main.data.model.*;
import com.lymsh.yimiao.main.data.service.MedKidsService;
import com.lymsh.yimiao.main.data.service.YmUserKidMapsService;
import com.lymsh.yimiao.main.data.service.YmUsersService;
import com.lymsh.yimiao.main.data.util.ImageUtil;
import com.lymsh.yimiao.main.data.util.LoginContext;
import com.lymsh.yimiao.main.data.util.LoginUtil;
import com.lymsh.yimiao.main.data.util.PhoneUtil;
import org.apache.commons.collections.CollectionUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.beans.factory.annotation.Value;
import org.springframework.http.MediaType;
import org.springframework.stereotype.Controller;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestMethod;
import org.springframework.web.bind.annotation.RequestParam;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import java.util.*;

/**
 *
 *  用户接口
 *
 * Created by Administrator on 2016/4/12 0012.
 */

@Controller
@RequestMapping("/v1")
public class UserController extends BaseController {

    @Value("#{configProperties['yimiao.token']}")
    private String token;
    @Value("#{configProperties['yimiao.typeId']}")
    private String typeId;
    @Autowired
    private YmUsersService usersService;
//    @Autowired
//    private TokenService tokenService;
    @Autowired
    private YmUserKidMapsService ymUserKidMapsService;
    @Autowired
    private MedKidsService medKidsService;

    /**
     * 发送验证码
     * @param response
     * @param phone     手机号
     */
    @RequestMapping(value = "/authCode", method = RequestMethod.GET, produces = MediaType.APPLICATION_JSON_VALUE + ";charset=utf-8")
    public void sendVercode(HttpServletResponse response,@RequestParam("phone") String phone) {

//        Boolean result = LoginUtil.sendVerCode(phone, typeId, token);
        LoginContext result = LoginUtil.sendCode(phone, typeId, token);
        if (result.getErrorcode()!=null&&result.getErrorcode()==0){
            ResultUtils.buildSuccessResultAndWrite(response);
        }else {
            ResultUtils.buildParameterErrorResultAndWrite(response,"发送验证码失败");
        }
    }


    /**
     * 登陆
     * @param response
     * @param phone     手机号
     * @param code      验证码
     */
    @RequestMapping(value = "/login", method = RequestMethod.POST)
    public void userLogin(HttpServletResponse response,
                          @RequestParam("phone") String phone,
                          @RequestParam("code") String code) {

        LoginContext result = LoginUtil.login(phone, code, typeId, token);
        Map<String, Object> map = new HashMap<>();

        //登陆的同时,在数据库创建账号,对手机号唯一性判断
        if (result.getToken()!=null){
            YmUsersQuery query = new YmUsersQuery();
            query.setPhone(phone);
            query.setYn(YnEnum.yes.getId());
            List<YmUsers> usersList = usersService.queryYmUsers(query);
            if (usersList.size()==0){
                YmUsers users = new YmUsers();
                users.setPhone(phone);

                users.setNickname(phone);
                users.setAvatar(ImageUtil.DEFAULTUSERAVATAR);

                users.setYn(YnEnum.yes.getId());
                users.setCreated(new Date());
                users.setLoginCenterId(result.getId());
                users.setLastLoginTime(new Date());
                usersService.addYmUsers(users);
                map.put("token", result.getToken());
                map.put("id", users.getId());
            }else {
                YmUsers users = usersList.get(0);
                users.setLastLoginTime(new Date());
                usersService.updateYmUsers(users);
                map.put("token", result.getToken());
                map.put("id", users.getId());
            }
            map.put("errorcode", ConstantInterface.SUCCESS);
            map.put("errormsg", "成功");
        }else {
            map.put("errorcode",ConstantInterface.SYSTEM_ERROR);
            map.put("errormsg", "登录失败");
        }
        writeJson(response, JsonUtil.obj2JsonString(map));
    }

    //暫時獲取token接口
//    @RequestMapping(value = "/userlogin", method = RequestMethod.POST)
//    public void userLogin(HttpServletResponse response,
//                          @RequestParam("phone") String phone){
//        YmUsersQuery query = new YmUsersQuery();
//        query.setPhone(phone);
//        query.setYn(YnEnum.yes.getId());
//        List<YmUsers> usersList = usersService.queryYmUsers(query);
//        Map<String, Object> map = new HashMap<>();
//        if (CollectionUtils.isNotEmpty(usersList)){
//            YmUsers users = usersList.get(0);
//            String token = tokenService.createToken(users.getId());
//            map.put("token", token);
//            map.put("id", users.getId());
//            users.setLastLoginTime(new Date());
//            usersService.updateYmUsers(users);
//            map.put("errorcode", 0);
//            map.put("errormsg", "成功");
//            writeJson(response,JsonUtil.obj2JsonString(map));
//        }else {
//            ResultUtils.buildParameterErrorResultAndWrite(response,"该手机号不存在,请注册");
//        }
//    }

    /**
     * 注册(暂时不需要注册接口)
     * @param response
     * @param phone     手机号
     */
//    @RequestMapping(value = "/register", method = RequestMethod.POST)
//    public void registerUser(HttpServletResponse response,
//                          @RequestParam("phone") String phone) {
//
//        LoginContext result = LoginUtil.register(phone, token, typeId);
//        Map<String, Object> map = new HashMap<>();
//        map.put("errorcode", result.getErrorcode());
//        map.put("errormsg", result.getErrormsg());
//        if (result.getId()!=null){
//            YmUsersQuery query = new YmUsersQuery();
//            query.setPhone(phone);
//            query.setYn(YnEnum.yes.getId());
//            List<YmUsers> usersList = usersService.queryYmUsers(query);
//            if (usersList.size()==0){
//                YmUsers user = new YmUsers();
//                user.setId(result.getId());
//                user.setYn(1);
//                user.setCreated(new Date());
//                user.setModified(new Date());
//                user.setPhone(phone);
//                user.setLoginCenterId(result.getId());
//                usersService.addYmUsers(user);
//            }
//        }
//        writeJson(response, JsonUtil.obj2JsonString(map));
//    }

    /**
     * 获取当前用户信息
     * @param response
     */
    @RequestMapping(value = "/userInfo", method = RequestMethod.GET)
    @TokenRequired
    public void getUserInfo(HttpServletResponse response,HttpServletRequest request){

        LoginContext loginContext = (LoginContext) request.getAttribute("loginContext");

        List<Map> list = new ArrayList<>();

        //取到当前登陆用户的id
        YmUsers users = usersService.getYmUsers(loginContext.getId());
        Map<String,Object> map = new HashMap<>();
        //如果没有昵称,返回手机
        map.put("nickname",users.getNickname()!=null ? users.getNickname() : users.getPhone());
        //如果没有头像,返回默认头像
        map.put("avatar", QiniuUtil.buildImg(users.getAvatar()!=null ? users.getAvatar() : ImageUtil.DEFAULTUSERAVATAR));

        map.put("phone", users.getPhone());

        list.add(map);

        ResultUtils.buildSuccessResultAndWrite(response,list);
    }

    /**
     * 修改绑定手机号接口
     * @param response
     * @param phone
     */
    @RequestMapping(value = "/updatePhone", method = RequestMethod.PUT)
    @TokenRequired
    public void updateUserPhone(HttpServletResponse response,
                                HttpServletRequest request,
                                @RequestParam("phone") String phone,
                                @RequestParam("code") String code) {
        LoginContext loginContext = (LoginContext) request.getAttribute("loginContext");
        //取到当前登陆用户的id
        YmUsers users = usersService.getYmUsers(loginContext.getId());

        Map<String, Object> resultMsgMap = new HashMap<>();
        //取出验证码
        Object verCodeObj = (Object) RedisUtils.getObj("c_" + phone);
        if (verCodeObj == null) {
            //参数错误
            resultMsgMap.put(ResultUtils.ERROR_CODE, ConstantInterface.VER_CODE_EXPIRE);
            resultMsgMap.put(ResultUtils.ERROR_MSG, "验证码已过期,请重新获取.");
            writeJson(response, com.lymsh.yimiao.main.data.util.JsonUtil.obj2JsonString(resultMsgMap));//把这个map转成一个json字符串输出到前台
            return;
        }
        //验证码正确
        if (code.equals(verCodeObj)){
            YmUsersQuery query = new YmUsersQuery();
            query.setYn(YnEnum.yes.getId());
            List<YmUsers> ymUsersList = usersService.queryYmUsers(query);
            if (CollectionUtils.isNotEmpty(ymUsersList)){
                for (YmUsers data : ymUsersList){
                    if (phone.equals(data.getPhone())){
                        ResultUtils.buildParameterErrorResultAndWrite(response,"当前手机已绑定,请重新输入");
                        return;
                    }
                }
            }
            if (PhoneUtil.isMobileNO(phone)) {
                //去登录中心注册账号,如果登录中心也有这个手机号,直接返回id
                LoginContext context = LoginUtil.register(phone,token,typeId);
                if (context!=null){
                    users.setLoginCenterId(context.getId());
                    users.setPhone(phone);
                    users.setModified(new Date());
                    usersService.updateYmUsers(users);
                    ResultUtils.buildSuccessResultAndWrite(response);
                }else {
                    ResultUtils.buildParameterErrorResultAndWrite(response,"更换绑定手机号失败");
                }
            }else {
                ResultUtils.buildParameterErrorResultAndWrite(response,"手机号输入错误");
            }
        }else {
            ResultUtils.buildParameterErrorResultAndWrite(response,"验证码错误,请重新输入");
        }
    }

    /**
     * 修改当前登录用户头像和昵称
     * @param response
     * @param avatar
     * @param nickname
     */
    @RequestMapping(value = "/userInfo", method = RequestMethod.PUT)
    @TokenRequired
    public void updateUser(HttpServletResponse response,
                           HttpServletRequest request,
                           @RequestParam(value = "avatar",required = false) String avatar,
                           @RequestParam(value = "nickname",required = false)String nickname) {
        LoginContext loginContext = (LoginContext) request.getAttribute("loginContext");

        //取到当前登陆用户的id
        YmUsers users = usersService.getYmUsers(loginContext.getId());
        users.setNickname(nickname);
        users.setAvatar(avatar);
        users.setModified(new Date());
        usersService.updateYmUsers(users);
        ResultUtils.buildSuccessResultAndWrite(response);
    }

    //获取用户所有关联的宝宝
    @RequestMapping(value = "/userBaby", method = RequestMethod.GET)
    @TokenRequired
    public void getUserBaby(HttpServletResponse response,HttpServletRequest request) {
        LoginContext loginContext = (LoginContext) request.getAttribute("loginContext");
        YmUsers users = usersService.getYmUsers(loginContext.getId());

        List<Map> list = new ArrayList<>();

        YmUserKidMapsQuery query = new YmUserKidMapsQuery();
        query.setUserId(users.getId());
        query.setYn(YnEnum.yes.getId());
        List<YmUserKidMaps> userKidMapsList = ymUserKidMapsService.queryYmUserKidMaps(query);
        if (CollectionUtils.isNotEmpty(userKidMapsList)){
            for (YmUserKidMaps data : userKidMapsList){
                Map<String,Object> map = new HashMap<>();
                map.put("id",data.getKidId());
                MedKids medKids = medKidsService.getMedKids(data.getKidId());
                map.put("name",medKids.getName());
                map.put("sex",medKids.getSex());
                list.add(map);
            }
        }
        ResultUtils.buildSuccessResultAndWrite(response,list);
    }

}
